]> git.ipfire.org Git - people/pmueller/ipfire-2.x.git/blob - make.sh
Kleines Tuning vom QoS...
[people/pmueller/ipfire-2.x.git] / make.sh
1 #!/bin/bash
2 ############################################################################
3 # #
4 # This file is part of the IPFire Firewall. #
5 # #
6 # IPFire is free software; you can redistribute it and/or modify #
7 # it under the terms of the GNU General Public License as published by #
8 # the Free Software Foundation; either version 2 of the License, or #
9 # (at your option) any later version. #
10 # #
11 # IPFire is distributed in the hope that it will be useful, #
12 # but WITHOUT ANY WARRANTY; without even the implied warranty of #
13 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the #
14 # GNU General Public License for more details. #
15 # #
16 # You should have received a copy of the GNU General Public License #
17 # along with IPFire; if not, write to the Free Software #
18 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA #
19 # #
20 # Copyright (C) 2006 IPFire-Team <info@ipfire.eu>. #
21 # #
22 ############################################################################
23 #
24
25 NAME="IPFire" # Software name
26 SNAME="ipfire" # Short name
27 VERSION="2.0b" # Version number
28 SLOGAN="www.ipfire.org" # Software slogan
29 CONFIG_ROOT=/var/ipfire # Configuration rootdir
30 NICE=10 # Nice level
31 MAX_RETRIES=1 # prefetch/check loop
32 KVER=`grep --max-count=1 VER lfs/linux | awk '{ print $3 }'`
33 MACHINE=`uname -m`
34 SVN_REVISION=`svn info | grep Revision | cut -c 11-`
35
36 IPFVER="full" # Which version should be compiled? (full|light|voice)
37
38 # Set an information about the build number
39 if [ -e ./.svn ]; then
40 FIREBUILD=`cat .svn/entries |sed -n 's/^[ \t]*revision=\"// p' | sed -n 's/\".*$// p'`
41 fi
42
43 # Debian specific settings
44 if [ ! -e /etc/debian_version ]; then
45 FULLPATH=`which $0`
46 else
47 if [ -x /usr/bin/realpath ]; then
48 FULLPATH=`/usr/bin/realpath $0`
49 else
50 echo "ERROR: Need to do apt-get install realpath"
51 exit 1
52 fi
53 fi
54
55 PWD=`pwd`
56 BASENAME=`basename $0`
57 BASEDIR=`echo $FULLPATH | sed "s/\/$BASENAME//g"`
58 LOGFILE=$BASEDIR/log/_build.preparation.log
59 export BASEDIR LOGFILE
60 DIR_CHK=$BASEDIR/cache/check
61 mkdir $BASEDIR/log/ 2>/dev/null
62
63 # Include funtions
64 . tools/make-functions
65
66 if [ -f .config ]; then
67 . .config
68 else
69 echo -e "${BOLD}No configuration found!${NORMAL}"
70 echo -ne "Do you want to create one (y/N)?"
71 read CREATE_CONFIG
72 echo ""
73 if [ "$CREATE_CONFIG" == "y" ]; then
74 make_config
75 fi
76 fi
77
78 prepareenv() {
79 ############################################################################
80 # #
81 # Are we running the right shell? #
82 # #
83 ############################################################################
84 if [ ! "$BASH" ]; then
85 exiterror "BASH environment variable is not set. You're probably running the wrong shell."
86 fi
87
88 if [ -z "${BASH_VERSION}" ]; then
89 exiterror "Not running BASH shell."
90 fi
91
92
93 ############################################################################
94 # #
95 # Trap on emergency exit #
96 # #
97 ############################################################################
98 trap "exiterror 'Build process interrupted'" SIGINT SIGTERM SIGKILL SIGSTOP SIGQUIT
99
100
101 ############################################################################
102 # #
103 # Resetting our nice level #
104 # #
105 ############################################################################
106 echo -ne "Resetting our nice level to $NICE" | tee -a $LOGFILE
107 renice $NICE $$ > /dev/null
108 if [ `nice` != "$NICE" ]; then
109 beautify message FAIL
110 exiterror "Failed to set correct nice level"
111 else
112 beautify message DONE
113 fi
114
115
116 ############################################################################
117 # #
118 # Checking if running as root user #
119 # #
120 ############################################################################
121 echo -ne "Checking if we're running as root user" | tee -a $LOGFILE
122 if [ `id -u` != 0 ]; then
123 beautify message FAIL
124 exiterror "Not building as root"
125 else
126 beautify message DONE
127 fi
128
129
130 ############################################################################
131 # #
132 # Checking for necessary temporary space #
133 # #
134 ############################################################################
135 echo -ne "Checking for necessary space on disk $BASE_DEV" | tee -a $LOGFILE
136 BASE_DEV=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $1 }'`
137 BASE_ASPACE=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $4 }'`
138 if (( 2048000 > $BASE_ASPACE )); then
139 BASE_USPACE=`du -skx $BASEDIR | awk '{print $1}'`
140 if (( 2048000 - $BASE_USPACE > $BASE_ASPACE )); then
141 beautify message FAIL
142 exiterror "Not enough temporary space available, need at least 2GB on $BASE_DEV"
143 fi
144 else
145 beautify message DONE
146 fi
147
148 ############################################################################
149 # #
150 # Building Linux From Scratch system #
151 # #
152 ############################################################################
153 # Set umask
154 umask 022
155
156 # Set LFS Directory
157 LFS=$BASEDIR/build
158
159 # Check /tools symlink
160 if [ -h /tools ]; then
161 rm -f /tools
162 fi
163 if [ ! -a /tools ]; then
164 ln -s $BASEDIR/build/tools /
165 fi
166 if [ ! -h /tools ]; then
167 exiterror "Could not create /tools symbolic link."
168 fi
169
170 # Setup environment
171 set +h
172 LC_ALL=POSIX
173 MAKETUNING="-j12"
174 export LFS LC_ALL CFLAGS CXXFLAGS MAKETUNING
175 unset CC CXX CPP LD_LIBRARY_PATH LD_PRELOAD
176
177 # Make some extra directories
178 mkdir -p $BASEDIR/build/{tools,etc,usr/src} 2>/dev/null
179 mkdir -p $BASEDIR/build/{dev/{shm,pts},proc,sys}
180 mkdir -p $BASEDIR/{cache,ccache} 2>/dev/null
181 mkdir -p $BASEDIR/build/usr/src/{cache,config,doc,html,langs,lfs,log,src,ccache}
182
183 mknod -m 600 $BASEDIR/build/dev/console c 5 1 2>/dev/null
184 mknod -m 666 $BASEDIR/build/dev/null c 1 3 2>/dev/null
185
186 # Make all sources and proc available under lfs build
187 mount --bind /dev $BASEDIR/build/dev
188 mount --bind /dev/pts $BASEDIR/build/dev/pts
189 mount --bind /dev/shm $BASEDIR/build/dev/shm
190 mount --bind /proc $BASEDIR/build/proc
191 mount --bind /sys $BASEDIR/build/sys
192 mount --bind $BASEDIR/cache $BASEDIR/build/usr/src/cache
193 mount --bind $BASEDIR/ccache $BASEDIR/build/usr/src/ccache
194 mount --bind $BASEDIR/config $BASEDIR/build/usr/src/config
195 mount --bind $BASEDIR/doc $BASEDIR/build/usr/src/doc
196 mount --bind $BASEDIR/html $BASEDIR/build/usr/src/html
197 mount --bind $BASEDIR/langs $BASEDIR/build/usr/src/langs
198 mount --bind $BASEDIR/lfs $BASEDIR/build/usr/src/lfs
199 mount --bind $BASEDIR/log $BASEDIR/build/usr/src/log
200 mount --bind $BASEDIR/src $BASEDIR/build/usr/src/src
201
202 # This is a temporary hack!!!
203 if [ ! -f /tools/bin/hostname ]; then
204 cp -f /bin/hostname /tools/bin/hostname 2>/dev/null
205 fi
206
207 # Run LFS static binary creation scripts one by one
208 export CCACHE_DIR=$BASEDIR/ccache
209 export CCACHE_HASHDIR=1
210
211 # Remove pre-install list of installed files in case user erase some files before rebuild
212 rm -f $BASEDIR/build/usr/src/lsalr 2>/dev/null
213 }
214
215 buildtoolchain() {
216 LOGFILE="$BASEDIR/log/_build.toolchain.log"
217 export LOGFILE
218 ORG_PATH=$PATH
219 NATIVEGCC=`gcc --version | grep GCC | awk {'print $3'}`
220 export NATIVEGCC GCCmajor=${NATIVEGCC:0:1} GCCminor=${NATIVEGCC:2:1} GCCrelease=${NATIVEGCC:4:1}
221 lfsmake1 ccache
222 lfsmake1 binutils PASS=1
223 lfsmake1 gcc PASS=1
224 export PATH=$BASEDIR/build/usr/local/bin:$BASEDIR/build/tools/bin:$PATH
225 lfsmake1 linux-libc-header
226 lfsmake1 glibc
227 lfsmake1 cleanup-toolchain PASS=1
228 lfsmake1 tcl
229 lfsmake1 expect
230 lfsmake1 dejagnu
231 lfsmake1 gcc PASS=2
232 lfsmake1 binutils PASS=2
233 lfsmake1 ncurses
234 lfsmake1 bash
235 lfsmake1 bzip2
236 lfsmake1 coreutils
237 lfsmake1 diffutils
238 lfsmake1 findutils
239 lfsmake1 gawk
240 lfsmake1 gettext
241 lfsmake1 grep
242 lfsmake1 gzip
243 lfsmake1 m4
244 lfsmake1 make
245 lfsmake1 patch
246 lfsmake1 perl
247 lfsmake1 sed
248 lfsmake1 tar
249 lfsmake1 texinfo
250 lfsmake1 util-linux
251 lfsmake1 cleanup-toolchain PASS=2
252 export PATH=$ORG_PATH
253 }
254
255 buildbase() {
256 LOGFILE="$BASEDIR/log/_build.base.log"
257 export LOGFILE
258 lfsmake2 stage2
259 lfsmake2 linux-libc-header
260 lfsmake2 man-pages
261 lfsmake2 glibc
262 lfsmake2 cleanup-toolchain PASS=3
263 lfsmake2 binutils
264 lfsmake2 gcc
265 lfsmake2 berkeley
266 lfsmake2 coreutils
267 lfsmake2 iana-etc
268 lfsmake2 m4
269 lfsmake2 bison
270 lfsmake2 ncurses
271 lfsmake2 procps
272 lfsmake2 sed
273 lfsmake2 libtool
274 lfsmake2 perl
275 lfsmake2 readline
276 lfsmake2 zlib
277 lfsmake2 autoconf
278 lfsmake2 automake
279 lfsmake2 bash
280 lfsmake2 bzip2
281 lfsmake2 diffutils
282 lfsmake2 e2fsprogs
283 lfsmake2 ed
284 lfsmake2 file
285 lfsmake2 findutils
286 lfsmake2 flex
287 lfsmake2 grub
288 lfsmake2 gawk
289 lfsmake2 gettext
290 lfsmake2 grep
291 lfsmake2 groff
292 lfsmake2 gzip
293 lfsmake2 inetutils
294 lfsmake2 iproute2
295 lfsmake2 kbd
296 lfsmake2 less
297 lfsmake2 make
298 lfsmake2 man
299 lfsmake2 mktemp
300 lfsmake2 modutils
301 lfsmake2 net-tools
302 lfsmake2 patch
303 lfsmake2 psmisc
304 lfsmake2 shadow
305 lfsmake2 sysklogd
306 lfsmake2 sysvinit
307 lfsmake2 tar
308 lfsmake2 texinfo
309 lfsmake2 udev
310 lfsmake2 util-linux
311 lfsmake2 vim
312 }
313
314 buildipfire() {
315 LOGFILE="$BASEDIR/log/_build.ipfire.log"
316 export LOGFILE
317 ipfiremake configroot
318 ipfiremake dhcp
319 ipfiremake dhcpcd
320 ipfiremake libusb
321 ipfiremake libpcap
322 ipfiremake linux-atm
323 ipfiremake ppp
324 ipfiremake rp-pppoe
325 ipfiremake unzip
326 ipfiremake linux SMP=1
327 ipfiremake ipp2p SMP=1
328 ipfiremake fcdsl SMP=1
329 ipfiremake fcdsl2 SMP=1
330 ipfiremake fcdslsl SMP=1
331 ipfiremake fcdslusb SMP=1
332 ipfiremake fcdslslusb SMP=1
333 ipfiremake fcpci SMP=1
334 # ipfiremake promise-sata-300-tx SMP=1
335 ipfiremake zaptel SMP=1
336 ipfiremake linux
337 ipfiremake ipp2p
338 ipfiremake fcdsl
339 ipfiremake fcdsl2
340 ipfiremake fcdslsl
341 ipfiremake fcdslusb
342 ipfiremake fcdslslusb
343 ipfiremake fcpci
344 # ipfiremake promise-sata-300-tx
345 ipfiremake zaptel
346 ipfiremake expat
347 ipfiremake gdbm
348 ipfiremake gmp
349 ipfiremake pam
350 ipfiremake openssl
351 ipfiremake python
352 ipfiremake libnet
353 ipfiremake libjpeg
354 ipfiremake libpng
355 ipfiremake libtiff
356 ipfiremake lcms
357 ipfiremake libmng
358 ipfiremake freetype
359 ipfiremake libart
360 ipfiremake gd
361 ipfiremake popt
362 ipfiremake pcre
363 ipfiremake slang
364 ipfiremake newt
365 ipfiremake libcap
366 ipfiremake pciutils
367 ipfiremake libxml2
368 ipfiremake BerkeleyDB
369 ipfiremake mysql
370 ipfiremake cyrus-sasl
371 ipfiremake openldap
372 ipfiremake apache2
373 ipfiremake php
374 ipfiremake apache2 PASS=C
375 ipfiremake arping
376 ipfiremake beep
377 ipfiremake bind
378 ipfiremake capi4k-utils
379 ipfiremake cdrtools
380 ipfiremake dnsmasq
381 ipfiremake dosfstools
382 ipfiremake reiserfsprogs
383 ipfiremake squashfstools
384 ipfiremake ethtool
385 ipfiremake ez-ipupdate
386 ipfiremake fcron
387 ipfiremake GD
388 ipfiremake gnupg
389 ipfiremake hdparm
390 ipfiremake ibod
391 ipfiremake initscripts
392 ipfiremake iptables
393 ipfiremake ipp2p IPT=1
394 ipfiremake ipac-ng
395 ipfiremake ipaddr
396 ipfiremake iptstate
397 ipfiremake iputils
398 ipfiremake l7-protocols
399 ipfiremake isapnptools
400 # ipfiremake isdn4k-utils # What about mISDN???
401 ipfiremake kudzu
402 ipfiremake logrotate
403 ipfiremake logwatch
404 ipfiremake misc-progs
405 ipfiremake mtools
406 ipfiremake nano
407 ipfiremake nash
408 ipfiremake nasm
409 ipfiremake URI
410 ipfiremake HTML-Tagset
411 ipfiremake HTML-Parser
412 ipfiremake Compress-Zlib
413 ipfiremake Digest
414 ipfiremake Digest-SHA1
415 ipfiremake Digest-HMAC
416 ipfiremake libwww-perl
417 ipfiremake Net-DNS
418 ipfiremake Net-IPv4Addr
419 ipfiremake Net_SSLeay
420 ipfiremake IO-Stringy
421 ipfiremake Unix-Syslog
422 ipfiremake Mail-Tools
423 ipfiremake MIME-Tools
424 ipfiremake Net-Server
425 ipfiremake Convert-TNEF
426 ipfiremake Convert-UUlib
427 ipfiremake Archive-Tar
428 ipfiremake Archive-Zip
429 ipfiremake Text-Tabs+Wrap
430 ipfiremake Locale-Country
431 ipfiremake GeoIP
432 ipfiremake fwhits
433 ipfiremake noip_updater
434 ipfiremake ntp
435 ipfiremake oinkmaster
436 ipfiremake openssh
437 ipfiremake openswan
438 ipfiremake pptpclient
439 ipfiremake rrdtool
440 ipfiremake setserial
441 ipfiremake setup
442 ipfiremake snort
443 ipfiremake squid
444 ipfiremake squid-graph
445 ipfiremake squidguard
446 ipfiremake tcpdump
447 ipfiremake traceroute
448 ipfiremake vlan
449 ipfiremake wireless
450 ipfiremake libsafe
451 ipfiremake 3c5x9setup
452 ipfiremake pakfire
453 ipfiremake java
454 ipfiremake bootsplash
455 ipfiremake spandsp
456 ipfiremake lzo
457 ipfiremake openvpn
458 ipfiremake pkg-config
459 ipfiremake glib
460 ipfiremake pammysql
461 ipfiremake xinetd
462 ipfiremake ghostscript
463 ipfiremake cups
464 ipfiremake samba
465 ipfiremake sudo
466 ipfiremake mc
467 ipfiremake wget
468 ipfiremake wput
469 ipfiremake bridge-utils
470 ipfiremake screen
471 ipfiremake hddtemp
472 ipfiremake smartmontools
473 ipfiremake htop
474 ipfiremake lynx
475 ipfiremake postfix
476 ipfiremake procmail
477 ipfiremake fetchmail
478 ipfiremake cyrusimap
479 ipfiremake webcyradm
480 ipfiremake mailx
481 ipfiremake clamav
482 ipfiremake razor
483 ipfiremake spamassassin
484 ipfiremake amavisd
485 ipfiremake stund
486 ipfiremake libpri
487 # ipfiremake bristuff
488 ipfiremake asterisk
489 ipfiremake mpg123
490 ipfiremake libmad
491 ipfiremake libogg
492 ipfiremake libvorbis
493 ipfiremake lame
494 ipfiremake xvid
495 ipfiremake mpeg2dec
496 ipfiremake ffmpeg
497 ipfiremake sox
498 ipfiremake gnump3d
499 ipfiremake videolan
500 ipfiremake applejuice
501 ipfiremake ocaml
502 ipfiremake mldonkey
503 ipfiremake ntop
504 ipfiremake rsync
505 ipfiremake tcpwrapper
506 ipfiremake portmap
507 ipfiremake nfs
508 ipfiremake nmap
509 ipfiremake mbmon
510 ipfiremake iftop
511 ipfiremake ncftp
512 ipfiremake cftp
513 ipfiremake etherwake
514 ipfiremake ethereal
515 ipfiremake tftp-hpa
516 ipfiremake iptraf
517 ipfiremake nagios
518 ipfiremake yasuc
519 }
520
521 buildinstaller() {
522 # Run installer scripts one by one
523 LOGFILE="$BASEDIR/log/_build.installer.log"
524 export LOGFILE
525 ipfiremake syslinux
526 ipfiremake memtest
527 installmake linux-libc-header
528 installmake binutils
529 ipfiremake uClibc PASS=1
530 ipfiremake gcc INST=1
531 installmake uClibc PASS=2
532 installmake gcc INST=2
533 installmake uClibc PASS=3
534 installmake busybox
535 installmake udev
536 installmake slang
537 installmake newt
538 installmake gettext
539 installmake kbd
540 installmake popt
541 installmake sysvinit
542 installmake misc-progs
543 installmake e2fsprogs
544 installmake reiserfsprogs
545 installmake sysfsutils
546 installmake util-linux
547 installmake pciutils
548 installmake kudzu
549 installmake installer
550 installmake initrd
551 }
552
553 buildpackages() {
554 LOGFILE="$BASEDIR/log/_build.packages.log"
555 export LOGFILE
556 echo "... see detailed log in _build.*.log files" >> $LOGFILE
557
558 installmake strip
559
560 # Generating list of packages used
561 echo -n "Generating packages list from logs" | tee -a $LOGFILE
562 rm -f $BASEDIR/doc/packages-list
563 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
564 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
565 echo "* `basename $i`" >>$BASEDIR/doc/packages-list
566 fi
567 done
568 echo "== List of softwares used to build $NAME Version: $VERSION ==" > $BASEDIR/doc/packages-list.txt
569 grep -v 'configroot$\|img$\|initrd$\|initscripts$\|installer$\|install$\|setup$\|pakfire$\|stage2$\|smp$\|tools$\|tools1$\|tools2$\|.tgz$\|-config$\|_missing_rootfile$' \
570 $BASEDIR/doc/packages-list | sort >> $BASEDIR/doc/packages-list.txt
571 rm -f $BASEDIR/doc/packages-list
572 # packages-list.txt is ready to be displayed for wiki page
573 beautify message DONE
574
575 # Create images for install
576 ipfiremake cdrom
577 ipfiremake pxe
578 cp -f $LFS/install/images/{*.iso,*.tgz} $BASEDIR >> $LOGFILE 2>&1
579
580 # ipfirepackages
581
582 # Cleanup
583 stdumount
584 rm -rf $BASEDIR/build/tmp/*
585
586 # Generating total list of files
587 echo "Generating files list from logs" | tee -a $LOGFILE
588 rm -f $BASEDIR/log/FILES
589 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
590 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
591 echo "##" >>$BASEDIR/log/FILES
592 echo "## `basename $i`" >>$BASEDIR/log/FILES
593 echo "##" >>$BASEDIR/log/FILES
594 cat $i | sed "s%^\./%#%" | sort >> $BASEDIR/log/FILES
595 fi
596 done
597 cd $BASEDIR/packages; ls -w1 *.ipfire | awk -F ".ipfire" '{ print $1 }' > $BASEDIR/packages/packages_list.txt
598 echo -n "###EOF###" >> $BASEDIR/packages/packages_list.txt
599
600 cd $PWD
601
602 }
603
604 ipfirepackages() {
605 if [ -d "$BASEDIR/packages" ]; then
606 for i in `ls $BASEDIR/packages`; do
607 touch $BASEDIR/build/install/packages/$i.empty
608 done
609 fi
610 # ipfiredist amavisd
611 ipfiredist applejuice
612 ipfiredist asterisk
613 ipfiredist clamav
614 ipfiredist cups
615 ipfiredist cyrusimap
616 ipfiredist fetchmail
617 ipfiredist ffmpeg
618 ipfiredist gnump3d
619 ipfiredist iptraf
620 ipfiredist java
621 ipfiredist lame
622 ipfiredist libmad
623 ipfiredist libogg
624 ipfiredist libvorbis
625 ipfiredist mailx
626 ipfiredist mldonkey
627 ipfiredist mpeg2dec
628 ipfiredist nagios
629 ipfiredist nfs
630 ipfiredist nmap
631 ipfiredist ntop
632 ipfiredist portmap
633 ipfiredist postfix
634 ipfiredist procmail
635 ipfiredist samba
636 ipfiredist sox
637 ipfiredist spamassassin
638 ipfiredist subversion
639 ipfiredist videolan
640 ipfiredist webcyradm
641 ipfiredist xvid
642 ipfiredist yasuc
643 test -d $BASEDIR/packages || mkdir $BASEDIR/packages
644 mv -f $LFS/install/packages/*.{ipfire,md5} $BASEDIR/packages >> $LOGFILE 2>&1
645 rm -rf $BASEDIR/build/install/packages/*
646 }
647
648 # See what we're supposed to do
649 case "$1" in
650 build)
651 clear
652 BUILDMACHINE=`uname -m`
653 PACKAGE=`ls -v -r $BASEDIR/cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz 2> /dev/null | head -n 1`
654 #only restore on a clean disk
655 if [ ! -f log/cleanup-toolchain-2-tools ]; then
656 if [ ! -n "$PACKAGE" ]; then
657 beautify build_stage "Full toolchain compilation - Native GCC: `gcc --version | grep GCC | awk {'print $3'}`"
658 prepareenv
659 buildtoolchain
660 else
661 PACKAGENAME=${PACKAGE%.tar.gz}
662 beautify build_stage "Packaged toolchain compilation"
663 if [ `md5sum $PACKAGE | awk '{print $1}'` == `cat $PACKAGENAME.md5 | awk '{print $1}'` ]; then
664 tar zxf $PACKAGE
665 prepareenv
666 else
667 exiterror "$PACKAGENAME md5 did not match, check downloaded package"
668 fi
669 fi
670 else
671 echo -n "Using installed toolchain" | tee -a $LOGFILE
672 beautify message SKIP
673 prepareenv
674 fi
675
676 beautify build_start
677 beautify build_stage "Building LFS"
678 buildbase
679
680 beautify build_stage "Building IPFire"
681 buildipfire
682
683 # Setzen des IPFire Builds
684 if [ "$FIREBUILD" ]; then
685 echo "$FIREBUILD" > $BASEDIR/build/var/ipfire/firebuild
686 else
687 echo "_(OvO)_" > $BASEDIR/build/var/ipfire/firebuild
688 fi
689
690 beautify build_stage "Building installer"
691 buildinstaller
692
693 beautify build_stage "Building packages"
694 buildpackages
695 beautify build_end
696 ;;
697 shell)
698 # enter a shell inside LFS chroot
699 # may be used to changed kernel settings
700 prepareenv
701 entershell
702 ;;
703 changelog)
704 echo -n "Loading new Changelog from SVN: "
705 svn log http://svn.ipfire.eu/svn/ipfire > doc/ChangeLog
706 beautify message DONE
707 ;;
708 clean)
709 echo -en "${BOLD}Cleaning build directory...${NORMAL}"
710 for i in `mount | grep $BASEDIR | sed 's/^.*loop=\(.*\))/\1/'`; do
711 $LOSETUP -d $i 2>/dev/null
712 done
713 for i in `mount | grep $BASEDIR | cut -d " " -f 1`; do
714 umount $i
715 done
716 stdumount
717 for i in `seq 0 7`; do
718 if ( losetup /dev/loop${i} 2>/dev/null | grep -q "/install/images" ); then
719 umount /dev/loop${i} 2>/dev/null;
720 losetup -d /dev/loop${i} 2>/dev/null;
721 fi;
722 done
723 rm -rf $BASEDIR/build
724 rm -rf $BASEDIR/cdrom
725 rm -rf $BASEDIR/packages
726 rm -rf $BASEDIR/log
727 if [ -h /tools ]; then
728 rm -f /tools
729 fi
730 beautify message DONE
731 ;;
732 downloadsrc)
733 if [ ! -d $BASEDIR/cache ]; then
734 mkdir $BASEDIR/cache
735 fi
736 mkdir -p $BASEDIR/log
737 echo -e "${BOLD}Preload all source files${NORMAL}" | tee -a $LOGFILE
738 FINISHED=0
739 cd $BASEDIR/lfs
740 for c in `seq $MAX_RETRIES`; do
741 if (( FINISHED==1 )); then
742 break
743 fi
744 FINISHED=1
745 cd $BASEDIR/lfs
746 for i in *; do
747 if [ -f "$i" -a "$i" != "Config" ]; then
748 echo -ne "Loading $i"
749 make -s -f $i LFS_BASEDIR=$BASEDIR MESSAGE="$i\t ($c/$MAX_RETRIES)" download >> $LOGFILE 2>&1
750 if [ $? -ne 0 ]; then
751 beautify message FAIL
752 FINISHED=0
753 else
754 if [ $c -eq 1 ]; then
755 beautify message DONE
756 fi
757 fi
758 fi
759 done
760 done
761 echo -e "${BOLD}***Verifying md5sums${NORMAL}"
762 ERROR=0
763 for i in *; do
764 if [ -f "$i" -a "$i" != "Config" ]; then
765 make -s -f $i LFS_BASEDIR=$BASEDIR MESSAGE="$i\t " md5 >> $LOGFILE 2>&1
766 if [ $? -ne 0 ]; then
767 echo -ne "MD5 difference in lfs/$i"
768 beautify message FAIL
769 ERROR=1
770 fi
771 fi
772 done
773 if [ $ERROR -eq 0 ]; then
774 echo -ne "${BOLD}all files md5sum match${NORMAL}"
775 beautify message DONE
776 else
777 echo -ne "${BOLD}not all files were correctly download${NORMAL}"
778 beautify message FAIL
779 fi
780 cd - >/dev/null 2>&1
781 ;;
782 toolchain)
783 clear
784 prepareenv
785 beautify build_stage "Toolchain compilation - Native GCC: `gcc --version | grep GCC | awk {'print $3'}`"
786 buildtoolchain
787 BUILDMACHINE=`uname -m`
788 echo "`date -u '+%b %e %T'`: Create toolchain tar.gz for $BUILDMACHINE" | tee -a $LOGFILE
789 test -d $BASEDIR/cache/toolchains || mkdir $BASEDIR/cache/toolchains
790 cd $BASEDIR && tar -zc --exclude='log/_build.*.log' -f cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz \
791 build/{bin,etc,usr/bin,usr/local} \
792 build/tools/{bin,etc,*-linux-gnu,include,lib,libexec,sbin,share,var} \
793 log >> $LOGFILE
794 md5sum cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz \
795 > cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.md5
796 stdumount
797 ;;
798 gettoolchain)
799 BUILDMACHINE=`uname -m`
800 # arbitrary name to be updated in case of new toolchain package upload
801 PACKAGE=$SNAME-$VERSION-toolchain-$BUILDMACHINE
802 if [ ! -f $BASEDIR/cache/toolchains/$PACKAGE.tar.gz ]; then
803 URL_TOOLCHAIN=`grep URL_TOOLCHAIN lfs/Config | awk '{ print $3 }'`
804 test -d $BASEDIR/cache/toolchains || mkdir $BASEDIR/cache/toolchains
805 echo "`date -u '+%b %e %T'`: Load toolchain tar.gz for $BUILDMACHINE" | tee -a $LOGFILE
806 cd $BASEDIR/cache/toolchains
807 wget $URL_TOOLCHAIN/$PACKAGE.tar.gz $URL_TOOLCHAIN/$PACKAGE.md5 >& /dev/null
808 if [ $? -ne 0 ]; then
809 echo "`date -u '+%b %e %T'`: error downloading toolchain for $BUILDMACHINE machine" | tee -a $LOGFILE
810 else
811 if [ "`md5sum $PACKAGE.tar.gz | awk '{print $1}'`" = "`cat $PACKAGE.md5 | awk '{print $1}'`" ]; then
812 echo "`date -u '+%b %e %T'`: toolchain md5 ok" | tee -a $LOGFILE
813 else
814 exiterror "$PACKAGE.md5 did not match, check downloaded package"
815 fi
816 fi
817 else
818 echo "Toolchain is already downloaded. Exiting..."
819 fi
820 ;;
821 othersrc)
822 prepareenv
823 echo -ne "`date -u '+%b %e %T'`: Build sources iso for $MACHINE" | tee -a $LOGFILE
824 chroot $LFS /tools/bin/env -i HOME=/root \
825 TERM=$TERM PS1='\u:\w\$ ' \
826 PATH=/usr/local/bin:/bin:/usr/bin:/sbin:/usr/sbin \
827 VERSION=$VERSION NAME="$NAME" SNAME="$SNAME" MACHINE=$MACHINE \
828 /bin/bash -x -c "cd /usr/src/lfs && make -f sources-iso LFS_BASEDIR=/usr/src install" >>$LOGFILE 2>&1
829 mv $LFS/install/images/ipfire-* $BASEDIR >> $LOGFILE 2>&1
830 if [ $? -eq "0" ]; then
831 beautify message DONE
832 else
833 beautify message FAIL
834 fi
835 stdumount
836 ;;
837 svn)
838 case "$2" in
839 update|up)
840 # clear
841 echo -ne "Loading the latest source files...\n"
842 if [ $3 ]; then
843 svn update -r $3 | tee -a $PWD/log/_build.svn.update.log
844 else
845 svn update | tee -a $PWD/log/_build.svn.update.log
846 fi
847 if [ $? -eq "0" ]; then
848 beautify message DONE
849 else
850 beautify message FAIL
851 exit 1
852 fi
853 echo -ne "Writing the svn-info to a file"
854 svn info > $PWD/svn_status
855 if [ $? -eq "0" ]; then
856 beautify message DONE
857 else
858 beautify message FAIL
859 exit 1
860 fi
861 chmod 755 $0
862 exit 0
863 ;;
864 commit|ci)
865 clear
866 if [ -f /usr/bin/mcedit ]; then
867 export EDITOR=/usr/bin/mcedit
868 fi
869 if [ -f /usr/bin/nano ]; then
870 export EDITOR=/usr/bin/nano
871 fi
872 echo -ne "Selecting editor $EDITOR..."
873 beautify message DONE
874 if [ -e /sbin/yast ]; then
875 if [ "`echo $SVN_REVISION | cut -c 3`" -eq "0" ]; then
876 $0 changelog
877 fi
878 fi
879 svn commit
880 $0 svn up
881 $0 uploadsrc
882 ;;
883 dist)
884 if [ $3 ]; then
885 SVN_REVISION=$3
886 fi
887 if [ -f ipfire-source-r$SVN_REVISION.tar.gz ]; then
888 echo -ne "REV $SVN_REVISION: SKIPPED!\n"
889 exit 0
890 fi
891 echo -en "REV $SVN_REVISION: Downloading..."
892 svn export http://svn.ipfire.eu/svn/ipfire/trunk ipfire-source/ --force > /dev/null
893 svn log http://svn.ipfire.eu/svn/ipfire/trunk -r 1:$SVN_REVISION > ipfire-source/Changelog
894 #svn info http://svn.ipfire.eu/svn/ipfire/trunk -r $SVN_REVISION > ipfire-source/svn_status
895 evaluate 1
896
897 echo -en "REV $SVN_REVISION: Compressing files..."
898 if [ -e ipfire-source/trunk/make.sh ]; then
899 chmod 755 ipfire-source/trunk/make.sh
900 fi
901 tar cfz ipfire-source-r$SVN_REVISION.tar.gz ipfire-source
902 evaluate 1
903 echo -en "REV $SVN_REVISION: Cleaning up..."
904 rm ipfire-source/ -r
905 evaluate 1
906 ;;
907 diff|di)
908 echo -ne "Make a local diff to last svn revision"
909 svn diff > ipfire-diff-`date +'%Y-%m-%d-%H:%M'`-r`svn info | grep Revision | cut -c 11-`.diff
910 evaluate 1
911 echo "Diff was successfully saved to ipfire-diff-`date +'%Y-%m-%d-%H:%M'`-r`svn info | grep Revision | cut -c 11-`.diff"
912 ;;
913 esac
914 ;;
915 uploadsrc)
916 PWD=`pwd`
917 cd $BASEDIR/cache/
918 echo -e "Uploading cache to ftp server:"
919 ncftpls -u $FTP_CACHE_USER -p $FTP_CACHE_PASS ftp://$FTP_CACHE_URL$FTP_CACHE_PATH/ > /var/tmp/ftplist
920 for i in *; do
921 if [ "$i" == "toolchains" ]; then continue; fi
922 grep -q $i /var/tmp/ftplist
923 if [ "$?" -ne "0" ]; then
924 echo -ne "$i"
925 ncftpput -u $FTP_CACHE_USER -p $FTP_CACHE_PASS $FTP_CACHE_URL $FTP_CACHE_PATH/ $i
926 if [ "$?" -eq "0" ]; then
927 beautify message DONE
928 else
929 beautify message FAIL
930 fi
931 fi
932 done
933 rm -f /var/tmp/ftplist
934 cd $PWD
935 exit 0
936 ;;
937 upload)
938 case "$2" in
939 iso)
940 echo -e "Uploading the iso to $IPFIRE_FTP_URL_EXT."
941 cat <<EOF > .ftp-commands
942 mkdir $IPFIRE_FTP_PATH_EXT
943 ls -lah
944 quit
945 EOF
946 ncftp -u $IPFIRE_FTP_USER_EXT -p $IPFIRE_FTP_PASS_EXT $IPFIRE_FTP_URL_EXT < .ftp-commands
947 rm -f .ftp-commands
948 md5sum ipfire-install-$VERSION.i386.iso > ipfire-install-$VERSION.i386.iso.md5
949 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL $FTP_ISO_PATH/ ipfire-install-$VERSION.i386.iso
950 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL $FTP_ISO_PATH/ ipfire-install-$VERSION.i386.iso.md5
951 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL $FTP_ISO_PATH/ ipfire-source-r$SVN_REVISION.tar.gz
952 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL $FTP_ISO_PATH/ svn_status
953 if [ "$?" -eq "0" ]; then
954 echo -e "The iso of Revision $SVN_REVISION was successfully uploaded to $IPFIRE_FTP_URL_EXT$IPFIRE_FTP_PATH_EXT/."
955 else
956 echo -e "There was an error while uploading the iso to the ftp server."
957 exit 1
958 fi
959 if [ "$3" = "--with-sources-cd" ]; then
960 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL $FTP_ISO_PATH/ ipfire-sources-cd-$VERSION.$MACHINE.iso
961 fi
962 ;;
963 paks)
964 cat <<EOF > .ftp-commands
965 mkdir $IPFIRE_FTP_PATH_PAK
966 ls -lah
967 quit
968 EOF
969 ncftp -u $IPFIRE_FTP_USER_PAK -p $IPFIRE_FTP_PASS_PAK $IPFIRE_FTP_URL_PAK < .ftp-commands
970 rm -f .ftp-commands
971 ncftpput -z -u $IPFIRE_FTP_USER_PAK -p $IPFIRE_FTP_PASS_PAK $IPFIRE_FTP_URL_PAK $IPFIRE_FTP_PATH_PAK/ packages/*
972 if [ "$?" -eq "0" ]; then
973 echo -e "The packages were successfully uploaded to $IPFIRE_FTP_URL_PAK$IPFIRE_FTP_PATH_PAK/."
974 else
975 echo -e "There was an error while uploading the packages to the ftp server."
976 exit 1
977 fi
978 ;;
979 esac
980 ;;
981 batch)
982 if [ "$2" -eq "--background" ]; then
983 batch_script
984 exit $?
985 fi
986 if [ `screen -ls | grep -q ipfire` ]; then
987 echo "Build is already running, sorry!"
988 exit 1
989 else
990 if [ "$2" = "--rebuild" ]; then
991 export IPFIRE_REBUILD=1
992 echo "REBUILD!"
993 else
994 export IPFIRE_REBUILD=0
995 fi
996 echo -en "${BOLD}***IPFire-Batch-Build is starting...${NORMAL}"
997 screen -dmS ipfire $0 batch --background
998 evaluate 1
999 exit 0
1000 fi
1001 ;;
1002 watch)
1003 watch_screen
1004 ;;
1005 pxe)
1006 case "$2" in
1007 start)
1008 start_tftpd
1009 ;;
1010 stop)
1011 stop_tftpd
1012 ;;
1013 reload|restart)
1014 reload_tftpd
1015 ;;
1016 esac
1017 exit 0
1018 ;;
1019 "")
1020 clear
1021 svn info
1022 select name in "Exit" "IPFIRE: Downloadsrc" "IPFIRE: Build (silent)" "IPFIRE: Watch Build" "IPFIRE: Batch" "IPFIRE: Clean" "SVN: Commit" "SVN: Update" "SVN: Status" "SVN: Diff" "LOG: Tail" "Help"
1023 do
1024 case $name in
1025 "IPFIRE: Downloadsrc")
1026 $0 downloadsrc
1027 ;;
1028 "IPFIRE: Build (silent)")
1029 $0 build-silent
1030 ;;
1031 "IPFIRE: Watch Build")
1032 $0 watch
1033 ;;
1034 "IPFIRE: Batch")
1035 $0 batch
1036 ;;
1037 "IPFIRE: Clean")
1038 $0 clean
1039 ;;
1040 "SVN: Update")
1041 $0 svn update
1042 ;;
1043 "Help")
1044 echo "Usage: $0 {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain}"
1045 cat doc/make.sh-usage
1046 ;;
1047 "LOG: Tail")
1048 tail -f log/_*
1049 ;;
1050 "Exit")
1051 break
1052 ;;
1053 esac
1054 done
1055 ;;
1056 config)
1057 make_config
1058 ;;
1059 *)
1060 echo "Usage: $0 {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain}"
1061 cat doc/make.sh-usage
1062 ;;
1063 esac